diff -r fb51f5b4aa4c trytond/model/modelstorage.py
--- a/trytond/model/modelstorage.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/model/modelstorage.py	Mon Sep 24 20:36:36 2012 +0200
@@ -3,31 +3,34 @@
 
 import datetime
 import time
-from decimal import Decimal
 import logging
-from itertools import chain
+import contextlib
+import traceback
+import sys
+import csv
 try:
     import cStringIO as StringIO
 except ImportError:
     import StringIO
-import csv
+
+from decimal import Decimal
+from itertools import islice, ifilter, ifilterfalse, chain
 from functools import reduce
-import traceback
-import sys
+
 from trytond.model import Model
 from trytond.model import fields
-from trytond.model.browse import BrowseRecordList, BrowseRecord, \
-        BrowseRecordNull
-from trytond.model.browse import EvalEnvironment
-from trytond.tools import safe_eval, reduce_domain, datetime_strftime
+from trytond.tools import safe_eval, reduce_domain
 from trytond.pyson import PYSONEncoder, PYSONDecoder, PYSON
-from trytond.const import OPERATORS, RECORD_CACHE_SIZE
+from trytond.const import OPERATORS, RECORD_CACHE_SIZE, BROWSE_FIELD_TRESHOLD
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 from trytond.cache import LRUDict
 from trytond.config import CONFIG
+from trytond.rpc import RPC
 from .modelview import ModelView
 
+__all__ = ['ModelStorage']
+
 
 class ModelStorage(Model):
     """
@@ -41,237 +44,211 @@
     rec_name = fields.Function(fields.Char('Name'), 'get_rec_name',
             searcher='search_rec_name')
 
-    def __init__(self):
-        super(ModelStorage, self).__init__()
-        if isinstance(self, ModelView):
-            self._rpc.update({
-                'create': True,
-                'read': False,
-                'write': True,
-                'delete': True,
-                'copy': True,
-                'search': False,
-                'search_count': False,
-                'search_read': False,
-                'export_data': False,
-                'import_data': True,
-            })
-        self._constraints = []
+    @classmethod
+    def __setup__(cls):
+        super(ModelStorage, cls).__setup__()
+        if issubclass(cls, ModelView):
+            cls.__rpc__.update({
+                    'create': RPC(readonly=False, result=int),
+                    'read': RPC(),
+                    'write': RPC(readonly=False, instantiate=0),
+                    'delete': RPC(readonly=False, instantiate=0),
+                    'copy': RPC(readonly=False, instantiate=0,
+                        result=lambda r: map(int, r)),
+                    'search': RPC(result=lambda r: map(int, r)),
+                    'search_count': RPC(),
+                    'search_read': RPC(),
+                    'export_data': RPC(instantiate=0),
+                    'import_data': RPC(readonly=False),
+                    })
+        cls._constraints = []
 
-    def default_create_uid(self):
+    @staticmethod
+    def default_create_uid():
         "Default value for uid field."
         return int(Transaction().user)
 
-    def default_create_date(self):
+    @staticmethod
+    def default_create_date():
         "Default value for create_date field."
         return datetime.datetime.today()
 
-    def __fields_by_model(self, values):
+    @classmethod
+    def __fields_by_model(cls, values):
         "Return a dictionary with list of fields from values grouped by model"
         fields_by_model = {}
         for field in values:
-            if field in self._columns:
-                model = self._name
+            if field in cls._fields:
+                model = cls.__name__
             else:
-                model = self._inherit_fields[field][0]
+                model = cls._inherit_fields[field][0]
             fields_by_model.setdefault(model, []).append(field)
         return fields_by_model
 
-    def create(self, values):
+    @classmethod
+    def create(cls, values):
         '''
-        Create records.
-
-        :param values: a dictionary with fields names as key
-                and created values as value
-        :return: the id of the created record
+        Create record and return an instance.
         '''
         pool = Pool()
-        model_access_obj = pool.get('ir.model.access')
-        model_field_access_obj = pool.get('ir.model.field.access')
+        ModelAccess = pool.get('ir.model.access')
+        ModelFieldAccess = pool.get('ir.model.field.access')
 
-        model_access_obj.check(self._name, 'create')
-        for model, fields in self.__fields_by_model(values).iteritems():
-            model_field_access_obj.check(model, fields, 'write')
-        return False
+        ModelAccess.check(cls.__name__, 'create')
+        for model, fields in cls.__fields_by_model(values).iteritems():
+            ModelFieldAccess.check(model, fields, 'write')
 
-    def trigger_create(self, id):
+        # Increase transaction counter
+        Transaction().counter += 1
+
+    @classmethod
+    def trigger_create(cls, record):
         '''
         Trigger create actions
+        '''
+        Trigger = Pool().get('ir.trigger')
+        triggers = Trigger.get_triggers(cls.__name__, 'create')
+        if not triggers:
+            return
+        for trigger in triggers:
+            if Trigger.eval(trigger, record):
+                Trigger.trigger_action([record], trigger)
 
-        :param id: the created id
+    @classmethod
+    def read(cls, ids, fields_names=None):
         '''
-        trigger_obj = Pool().get('ir.trigger')
-        trigger_ids = trigger_obj.get_triggers(self._name, 'create')
-        if not trigger_ids:
-            return
-        record = self.browse(id)
-        triggers = trigger_obj.browse(trigger_ids)
-        for trigger in triggers:
-            if trigger_obj.eval(trigger, record):
-                trigger_obj.trigger_action([id], trigger.id)
-
-    def read(self, ids, fields_names=None):
-        '''
-        Read records.
-
-        :param ids: a list of ids or an id
-        :param fields_names: fields names to read if None read all fields
-        :return: a list of dictionnary or a dictionnary if ids is an id
-            the dictionnaries will have fields names as key
-            and fields value as value. The list will not be in the same order.
+        Read fields_names of record ids.
+        If fields_names is None, it read all fields.
+        The order is not guaranteed.
         '''
         pool = Pool()
-        model_access_obj = pool.get('ir.model.access')
-        model_field_access_obj = pool.get('ir.model.field.access')
+        ModelAccess = pool.get('ir.model.access')
+        ModelFieldAccess = pool.get('ir.model.field.access')
 
-        model_access_obj.check(self._name, 'read')
-        model_field_access_obj.check(self._name,
-                fields_names or self._columns.keys(), 'read')
+        ModelAccess.check(cls.__name__, 'read')
+        ModelFieldAccess.check(cls.__name__,
+                fields_names or cls._fields.keys(), 'read')
         if isinstance(ids, (int, long)):
             return {}
         return []
 
-    def write(self, ids, values):
+    @classmethod
+    def write(cls, records, values):
         '''
         Write values on records.
-
-        :param ids: a list of ids or an id
-        :param values: a dictionary with fields names as key
-                and written values as value
-        :return: True if succeed
         '''
         pool = Pool()
-        model_access_obj = pool.get('ir.model.access')
-        model_field_access_obj = pool.get('ir.model.field.access')
+        ModelAccess = pool.get('ir.model.access')
+        ModelFieldAccess = pool.get('ir.model.field.access')
 
-        model_access_obj.check(self._name, 'write')
-        for model, fields in self.__fields_by_model(values).iteritems():
-            model_field_access_obj.check(model, fields, 'write')
-        if not self.check_xml_record(ids, values):
-            self.raise_user_error('write_xml_record',
+        ModelAccess.check(cls.__name__, 'write')
+        for model, fields in cls.__fields_by_model(values).iteritems():
+            ModelFieldAccess.check(model, fields, 'write')
+        if not cls.check_xml_record(records, values):
+            cls.raise_user_error('write_xml_record',
                     error_description='xml_record_desc')
 
+        # Increase transaction counter
+        Transaction().counter += 1
+
+        # Clean local cache
+        for record in records:
+            local_cache = record._local_cache.get(record.id)
+            if local_cache:
+                local_cache.clear()
+
+        # Clean cursor cache
+        for cache in Transaction().cursor.cache.itervalues():
+            if cls.__name__ in cache:
+                for record in records:
+                    if record.id in cache[cls.__name__]:
+                        cache[cls.__name__][record.id].clear()
+
+    @classmethod
+    def trigger_write_get_eligibles(cls, records):
+        '''
+        Return eligible records for write actions by triggers
+        '''
+        Trigger = Pool().get('ir.trigger')
+        triggers = Trigger.get_triggers(cls.__name__, 'write')
+        if not triggers:
+            return {}
+        eligibles = {}
+        for trigger in triggers:
+            eligibles[trigger] = []
+            for record in records:
+                if not Trigger.eval(trigger, record):
+                    eligibles[trigger].append(record)
+        return eligibles
+
+    @classmethod
+    def trigger_write(cls, eligibles):
+        '''
+        Trigger write actions.
+        eligibles is a dictionary of the lists of eligible records by triggers
+        '''
+        Trigger = Pool().get('ir.trigger')
+        for trigger, records in eligibles.iteritems():
+            triggered = []
+            for record in records:
+                if Trigger.eval(trigger, record):
+                    triggered.append(record)
+            if triggered:
+                Trigger.trigger_action(triggered, trigger)
+
+    @classmethod
+    def delete(cls, records):
+        '''
+        Delete records.
+        '''
+        ModelAccess = Pool().get('ir.model.access')
+
+        ModelAccess.check(cls.__name__, 'delete')
+        if not cls.check_xml_record(records, None):
+            cls.raise_user_error('delete_xml_record',
+                    error_description='xml_record_desc')
+
+        # Increase transaction counter
+        Transaction().counter += 1
+
         # Clean cursor cache
         for cache in Transaction().cursor.cache.values():
             for cache in (cache, cache.get('_language_cache', {}).values()):
-                if self._name in cache:
-                    if isinstance(ids, (int, long)):
-                        ids = [ids]
-                    for i in ids:
-                        if i in cache[self._name]:
-                            cache[self._name][i] = {}
-        return False
+                if cls.__name__ in cache:
+                    for record in records:
+                        if record.id in cache[cls.__name__]:
+                            del cache[cls.__name__][record.id]
 
-    def trigger_write_get_eligibles(self, ids):
-        '''
-        Return eligible ids for write actions by triggers
-
-        :param ids: a list of ids
-        :return: a dictionary of the lists of eligible ids by triggers
-        '''
-        trigger_obj = Pool().get('ir.trigger')
-        trigger_ids = trigger_obj.get_triggers(self._name, 'write')
-        if not trigger_ids:
-            return {}
-        records = self.browse(ids)
-        triggers = trigger_obj.browse(trigger_ids)
-        eligibles = {}
-        for trigger in triggers:
-            eligibles[trigger.id] = []
-            for record in records:
-                if not trigger_obj.eval(trigger, record):
-                    eligibles[trigger.id].append(record.id)
-        return eligibles
-
-    def trigger_write(self, eligibles):
-        '''
-        Trigger write actions
-
-        :param eligibles: a dictionary of the lists of eligible ids by triggers
-        '''
-        trigger_obj = Pool().get('ir.trigger')
-        trigger_ids = eligibles.keys()
-        if not trigger_ids:
-            return
-        records = self.browse(list(chain(*eligibles.values())))
-        id2record = dict((x.id, x) for x in records)
-        triggers = trigger_obj.browse(trigger_ids)
-        for trigger in triggers:
-            triggered_ids = []
-            for record_id in eligibles[trigger.id]:
-                record = id2record[record_id]
-                if trigger_obj.eval(trigger, record):
-                    triggered_ids.append(record.id)
-            if triggered_ids:
-                trigger_obj.trigger_action(triggered_ids, trigger.id)
-
-    def delete(self, ids):
-        '''
-        Delete records.
-
-        :param ids: a list of ids or an id
-        :return: True if succeed
-        '''
-        model_access_obj = Pool().get('ir.model.access')
-
-        model_access_obj.check(self._name, 'delete')
-        if not self.check_xml_record(ids, None):
-            self.raise_user_error('delete_xml_record',
-                    error_description='xml_record_desc')
-
-        # Clean cursor cache
-        for cache in Transaction().cursor.cache.values():
-            for cache in (cache, cache.get('_language_cache', {}).values()):
-                if self._name in cache:
-                    if isinstance(ids, (int, long)):
-                        ids = [ids]
-                    for i in ids:
-                        if i in cache[self._name]:
-                            del cache[self._name][i]
-        return False
-
-    def trigger_delete(self, ids):
+    @classmethod
+    def trigger_delete(cls, records):
         '''
         Trigger delete actions
+        '''
+        Trigger = Pool().get('ir.trigger')
+        triggers = Trigger.get_triggers(cls.__name__, 'delete')
+        if not triggers:
+            return
+        for trigger in triggers:
+            triggered = []
+            for record in records:
+                if Trigger.eval(trigger, record):
+                    triggered.append(record)
+            if triggered:
+                Trigger.trigger_action(triggered, trigger)
 
-        :param ids: the deleted ids
+    @classmethod
+    def copy(cls, records, default=None):
         '''
-        trigger_obj = Pool().get('ir.trigger')
-        trigger_ids = trigger_obj.get_triggers(self._name, 'delete')
-        if not trigger_ids:
-            return
-        records = self.browse(ids)
-        triggers = trigger_obj.browse(trigger_ids)
-        for trigger in triggers:
-            triggered_ids = []
-            for record in records:
-                if trigger_obj.eval(trigger, record):
-                    triggered_ids.append(record.id)
-            if triggered_ids:
-                trigger_obj.trigger_action(triggered_ids, trigger.id)
-
-    def copy(self, ids, default=None):
-        '''
-        Duplicate the record(s) in ids.
-
-        :param ids: a list of ids or an id
-        :param default: a dictionary with field name as keys and
-            new value for the field as value
-        :return: a list of new ids or the new id
+        Duplicate the records and return a list of new records.
         '''
         pool = Pool()
-        lang_obj = pool.get('ir.lang')
+        Lang = pool.get('ir.lang')
         if default is None:
             default = {}
 
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
-
         if 'state' not in default:
-            if 'state' in self._defaults:
-                default['state'] = self._defaults['state']()
+            if 'state' in cls._defaults:
+                default['state'] = cls._defaults['state']()
 
         def convert_data(field_defs, data):
             data = data.copy()
@@ -309,145 +286,94 @@
             return data, data_o2m
 
         new_ids = {}
-        fields_names = self._columns.keys()
-        datas = self.read(ids, fields_names=fields_names)
-        field_defs = self.fields_get(fields_names=fields_names)
+        fields_names = cls._fields.keys()
+        ids = map(int, records)
+        datas = cls.read(ids, fields_names=fields_names)
+        field_defs = cls.fields_get(fields_names=fields_names)
         for data in datas:
             data_id = data['id']
             data, data_o2m = convert_data(field_defs, data)
-            new_ids[data_id] = self.create(data)
+            new_record = cls.create(data)
+            if new_record:
+                new_ids[data_id] = new_record.id
+            else:
+                continue
             for field_name in data_o2m:
-                relation_model = pool.get(
+                Relation = pool.get(
                         field_defs[field_name]['relation'])
                 relation_field = field_defs[field_name]['relation_field']
                 if relation_field:
-                    relation_model.copy(data_o2m[field_name],
-                            default={relation_field: new_ids[data_id]})
+                    Relation.copy(Relation.browse(data_o2m[field_name]),
+                        default={relation_field: new_ids[data_id]})
 
         fields_translate = {}
         for field_name, field in field_defs.iteritems():
-            if field_name in self._columns and \
-                    getattr(self._columns[field_name], 'translate', False):
+            if field_name in cls._fields and \
+                    getattr(cls._fields[field_name], 'translate', False):
                 fields_translate[field_name] = field
 
         if fields_translate:
-            lang_ids = lang_obj.search([
+            lang_ids = Lang.search([
                 ('translatable', '=', True),
                 ])
             if lang_ids:
-                lang_ids += lang_obj.search([
+                lang_ids += Lang.search([
                     ('code', '=', CONFIG['language']),
                     ])
-                langs = lang_obj.browse(lang_ids)
+                langs = Lang.browse(lang_ids)
                 for lang in langs:
                     with Transaction().set_context(language=lang.code):
-                        datas = self.read(ids,
+                        datas = cls.read(ids,
                                 fields_names=fields_translate.keys() + ['id'])
                         for data in datas:
                             data_id = data['id']
                             data, _ = convert_data(fields_translate, data)
-                            self.write(new_ids[data_id], data)
-        if int_id:
-            return new_ids.values()[0]
-        return new_ids.values()
+                            cls.write([cls(new_ids[data_id])], data)
+        return cls.browse(new_ids.values())
 
-    def search(self, domain, offset=0, limit=None, order=None, count=False):
+    @classmethod
+    def search(cls, domain, offset=0, limit=None, order=None, count=False):
         '''
-        Return a list of ids that match the domain.
-
-        :param domain: a list of tuples or lists
-            lists are constructed like this:
-            ``['operator', args, args, ...]``
-            operator can be 'AND' or 'OR', if it is missing the default
-            value will be 'AND'
-            tuples are constructed like this:
-            ``('field name', 'operator', value)``
-            field name: is a field name from the model or a relational field
-            by using '.' as separator.
-            operator must be in OPERATORS
-        :param offset: an integer to specify the offset of the result
-        :param limit: an integer to specify the number of result
-        :param order: a list of tuples that are constructed like this:
-            ``('field name', 'DESC|ASC')``
-            allowing to specify the order of result
-        :param count: a boolean to return only the length of the result
-        :return: a list of ids or an integer
+        Return a list of records that match the domain.
         '''
         if count:
             return 0
         return []
 
-    def search_count(self, domain):
+    @classmethod
+    def search_count(cls, domain):
         '''
-        Return the number of records that match the domain. (See search)
-
-        :param domain: a domain like in search
-        :return: an integer
+        Return the number of records that match the domain.
         '''
-        res = self.search(domain, count=True)
+        res = cls.search(domain, count=True)
         if isinstance(res, list):
             return len(res)
         return res
 
-    def search_read(self, domain, offset=0, limit=None, order=None,
+    @classmethod
+    def search_read(cls, domain, offset=0, limit=None, order=None,
             fields_names=None):
         '''
         Call search and read functions at once.
         Useful for the client to reduce the number of calls.
-
-        :param domain: a domain like in search
-        :param offset: an integer to specify the offset for the result
-        :param limit: an integer to specify the number of records
-        :param order: a list of tuples that are constructed like this:
-            ('field name', 'DESC|ASC')
-            allowing to to specify the order of result
-        :param fields_names: fields names to read if None read all fields
-        :return: a list of dictionaries or a dictionary if limit is 1
-            the dictionaries will have field names as key
-            and field values as value
         '''
-        ids = self.search(domain, offset=offset, limit=limit, order=order)
+        records = cls.search(domain, offset=offset, limit=limit, order=order)
 
         if not fields_names:
-            fields_names = list(set(self._columns.keys() \
-                    + self._inherit_fields.keys()))
+            fields_names = list(set(cls._fields.keys() \
+                    + cls._inherit_fields.keys()))
         if 'id' not in fields_names:
             fields_names.append('id')
+        return cls.read(map(int, records), fields_names)
 
-        res = []
-        for model in self.browse(ids):
-            record = {}
-            for fields_name in set(fields_names):
-                fields_split = fields_name.split('.')
-                while fields_split:
-                    field_name = fields_split.pop(0)
-                    if fields_name not in record:
-                        record[fields_name] = model[field_name]
-                    else:
-                        if isinstance(record[fields_name], BrowseRecordNull):
-                            continue
-                        record[fields_name] = record[fields_name][field_name]
-                if isinstance(record[fields_name], BrowseRecordNull):
-                    record[fields_name] = False
-                elif isinstance(record[fields_name], BrowseRecord):
-                    record[fields_name] = record[fields_name].id
-                elif isinstance(record[fields_name], BrowseRecordList):
-                    record[fields_name] = [x.id for x in record[fields_name]]
-            res.append(record)
-
-        if limit == 1:
-            if not ids:
-                return []
-            return res[0]
-        return res
-
-    def _search_domain_active(self, domain, active_test=True):
+    @classmethod
+    def _search_domain_active(cls, domain, active_test=True):
         # reduce_domain return a new instance so we can safety modify domain
         domain = reduce_domain(domain)
         # if the object has a field named 'active', filter out all inactive
         # records unless they were explicitely asked for
-        if not (('active' in self._columns
-            or 'active' in self._inherit_fields.keys())
+        if not (('active' in cls._fields
+            or 'active' in cls._inherit_fields.keys())
             and (active_test
                 and Transaction().context.get('active_test', True))):
             return domain
@@ -476,55 +402,39 @@
             return domain
         return process(domain)
 
-    def get_rec_name(self, ids, name):
+    def get_rec_name(self, name):
         '''
-        Return a dictionary with id as key and rec_name as value.
+        Return the rec_name of the instance.
         It is used by the Function field rec_name.
-
-        :param ids: a list of ids
-        :param name: the name of the Function field
-        :return: a dictionary
         '''
-        if not ids:
-            return {}
-        res = {}
         rec_name = self._rec_name
-        if (rec_name not in self._columns
+        if (rec_name not in self._fields
                 and rec_name not in self._inherit_fields):
             rec_name = 'id'
-        for record in self.browse(ids):
-            res[record.id] = unicode(record[rec_name])
-        return res
+        return unicode(getattr(self, rec_name))
 
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         '''
         Return a list of arguments for search on rec_name.
-
-        :param name: the name of the Function field
-        :param clause: a domain clause
-        :return: a list of domain clause
         '''
-        rec_name = self._rec_name
-        if (rec_name not in self._columns
-                and rec_name not in self._inherit_fields):
+        rec_name = cls._rec_name
+        if (rec_name not in cls._fields
+                and rec_name not in cls._inherit_fields):
             return []
         return [(rec_name,) + clause[1:]]
 
-    def browse(self, ids):
+    @classmethod
+    def browse(cls, ids):
         '''
-        Return a BrowseRecordList for the ids
-            or BrowseRecord if ids is a integer.
+        Return a list of instance for the ids
+        '''
+        ids = map(int, ids)
+        local_cache = LRUDict(RECORD_CACHE_SIZE)
+        return [cls(int(x), _ids=ids, _local_cache=local_cache) for x in ids]
 
-        :param ids: a list of ids or an id
-        :return: a BrowseRecordList or a BrowseRecord
-        '''
-        local_cache = LRUDict(RECORD_CACHE_SIZE)
-        if isinstance(ids, (int, long)):
-            return BrowseRecord(ids, self, [ids], local_cache)
-        return BrowseRecordList((BrowseRecord(x, self, ids, local_cache)
-            for x in ids))
-
-    def __export_row(self, record, fields_names):
+    @staticmethod
+    def __export_row(record, fields_names):
         pool = Pool()
         lines = []
         data = ['' for x in range(len(fields_names))]
@@ -536,21 +446,21 @@
             value = record
             i = 0
             while i < len(fields_tree):
-                if not isinstance(value, BrowseRecord):
+                if not isinstance(value, ModelStorage):
                     break
                 field_name = fields_tree[i]
-                model_obj = pool.get(value._model_name)
-                if field_name in model_obj._columns:
-                    field = model_obj._columns[field_name]
-                elif field_name in model_obj._inherit_fields:
-                    field = model_obj._inherit_fields[field_name][2]
+                eModel = pool.get(value.__name__)
+                if field_name in eModel._fields:
+                    field = eModel._fields[field_name]
+                elif field_name in eModel._inherit_fields:
+                    field = eModel._inherit_fields[field_name][2]
                 else:
                     raise Exception('Field %s not available on object "%s"'
-                        % (field_name, model_obj._name))
+                        % (field_name, eModel.__name__))
                 if field.states and 'invisible' in field.states:
                     pyson_invisible = PYSONEncoder().encode(
                             field.states['invisible'])
-                    env = EvalEnvironment(value, model_obj)
+                    env = EvalEnvironment(value, eModel)
                     env.update(Transaction().context)
                     env['current_date'] = datetime.datetime.today()
                     env['time'] = time
@@ -560,8 +470,8 @@
                     if invisible:
                         value = ''
                         break
-                value = value[field_name]
-                if isinstance(value, (BrowseRecordList, list)):
+                value = getattr(value, field_name)
+                if isinstance(value, (list, tuple)):
                     first = True
                     child_fields_names = [(x[:i + 1] == fields_tree[:i + 1] and
                         x[i + 1:]) or [] for x in fields_names]
@@ -569,7 +479,7 @@
                         break
                     done.append(child_fields_names)
                     for child_record in value:
-                        child_lines = self.__export_row(child_record,
+                        child_lines = ModelStorage.__export_row(child_record,
                                 child_fields_names)
                         if first:
                             for child_fpos in xrange(len(fields_names)):
@@ -585,33 +495,30 @@
             if i == len(fields_tree):
                 if value is None:
                     value = ''
+                elif isinstance(value, Model):
+                    value = str(value)
                 data[fpos] = value
         return [data] + lines
 
-    def export_data(self, ids, fields_names):
+    @classmethod
+    def export_data(cls, records, fields_names):
         '''
-        Return list of list of values for each id in ids.
+        Return list of list of values for each record.
         The list of values follows fields_names.
         Relational fields are defined with '/' at any depth.
-
-        :param ids: a list of ids
-        :param fields_names: a list of field names
-        :return: a list of list of values for each id in ids
         '''
         fields_names = [x.split('/') for x in fields_names]
-        datas = []
-        for record in self.browse(ids):
-            datas += self.__export_row(record, fields_names)
-        return datas
+        data = []
+        for record in records:
+            data += cls.__export_row(record, fields_names)
+        return data
 
-    def import_data(self, fields_names, datas):
+    @classmethod
+    def import_data(cls, fields_names, data):
         '''
-        Create records for all values in datas.
+        Create records for all values in data.
         The field names of values must be defined in fields_names.
-
-        :param fields_names: a list of fields names
-        :param datas: the data to import
-        :return: a tuple with
+        It returns a tuple with
             - the number of records imported
             - the last values if failed
             - the exception if failed
@@ -619,17 +526,17 @@
         '''
         pool = Pool()
 
-        def process_lines(self, datas, prefix, fields_def, position=0):
+        def process_lines(data, prefix, fields_def, position=0):
 
             def warn(msgname, *args):
-                msg = self.raise_user_error(msgname, args,
+                msg = cls.raise_user_error(msgname, args,
                         raise_exception=False)
                 warnings.warn(msg)
 
             def get_selection(selection, value):
                 res = None
                 if not isinstance(selection, (tuple, list)):
-                    selection = getattr(self, selection)()
+                    selection = getattr(cls, selection)()
                 for key, _ in selection:
                     if str(key) == value:
                         res = key
